/* $Id: dbnj_list.h,v 1.17 2005/10/24 08:42:44 oohara Exp $ */

#ifndef __LIBDBNJ_LIST_H__
#define __LIBDBNJ_LIST_H__

/* FILE */
#include <stdio.h>

struct _dbnj_list
{
  struct _dbnj_list *prev;
  struct _dbnj_list *next;
  void *data;
  void (*data_delete_func)(void *);
};
typedef struct _dbnj_list dbnj_list;

dbnj_list *dbnj_list_new(int n_errfile, FILE **p_errfile,
                         void *data, void (*data_delete_func)(void *));
int dbnj_list_delete(int n_errfile, FILE **p_errfile,
                     dbnj_list *list);
dbnj_list *dbnj_list_first(int n_errfile, FILE **p_errfile,
                           dbnj_list *list);
dbnj_list *dbnj_list_last(int n_errfile, FILE **p_errfile,
                          dbnj_list *list);
dbnj_list *dbnj_list_nth(int n_errfile, FILE **p_errfile,
                         dbnj_list *list, int n);
int dbnj_list_length_before(int n_errfile, FILE **p_errfile,
                            dbnj_list *list);
int dbnj_list_length_after(int n_errfile, FILE **p_errfile,
                           dbnj_list *list);
int dbnj_list_length_total(int n_errfile, FILE **p_errfile,
                           dbnj_list *list);
dbnj_list *dbnj_list_concat(int n_errfile, FILE **p_errfile,
                            dbnj_list *list1, dbnj_list *list2);
dbnj_list *dbnj_list_remove_link(int n_errfile, FILE **p_errfile,
                                 dbnj_list *list, dbnj_list *target);

#endif /* not __LIBDBNJ_LIST_H__ */
