/* $Id: dbnj_sdl.h,v 1.19 2007/05/17 01:27:23 oohara Exp $ */

#ifndef __LIBDBNJ_SDL_H__
#define __LIBDBNJ_SDL_H__

/* FILE */
#include <stdio.h>

#include <SDL.h>
/* libsdl-ttf2.0 */
#include <SDL_ttf.h>

SDL_Surface *dbnj_sdl_init(int n_errfile, FILE **p_errfile,
                           int x, int y, int full_screen,
                           const char *name);
int dbnj_sdl_clock_granularity(void);
void dbnj_sdl_wait(int tick_begin, int ms, int clock_granularity);
TTF_Font *dbnj_open_font(int n_errfile, FILE **p_errfile,
                         const char *ttf_font_file, int ptsize);
int dbnj_draw_rectangle(int n_errfile, FILE **p_errfile,
                        SDL_Surface *surface,
                        int x, int y, int w, int h,
                        int red, int green, int blue);
int dbnj_draw_text(int n_errfile, FILE **p_errfile,
                   SDL_Surface *surface, TTF_Font *font, int antialias,
                   int x, int y, int align, const char *text,
                   int red, int green, int blue, int alpha);

#endif /* not __LIBDBNJ_SDL_H__ */
