/* $Id: markov.h,v 1.8 2005/10/26 11:43:26 oohara Exp $ */

#ifndef __TMH_MARKOV_H__
#define __TMH_MARKOV_H__

#include "dbnj_hash_table.h"

struct _markov 
{
  /* key: char *, data: int * */
  dbnj_hash_table *hash_table;
  int n_state;
  char **p_state;
  int *n_next;
  char ***p_next;
  const char *previous;
};
typedef struct _markov markov;

markov *markov_new(int n_errfile, FILE **p_errfile);
void markov_delete(int n_errfile, FILE **p_errfile,
                   markov *chain);
int markov_insert(int n_errfile, FILE **p_errfile,
                  markov *chain,
                  const char *state, const char *next);
const char *markov_next(int n_errfile, FILE **p_errfile,
                        markov *chain);

#endif /* not __TMH_MARKOV_H__ */
